{$R+}
uses
  Classes, Math;

type
  THouse = record x1, y1, x2, y2, h: Integer; end;
  TWall = record a1, a2, b, h: Integer; end;
  PWall = ^TWall;

  function IsectArea(a1, a2, ah, b1, b2, bh: Integer): Integer;
  begin
    Result := 2 * Max((Min(a2, b2) - Max(a1, b1)) * Min(ah, bh), 0);
  end;

  function CompareWalls(w1, w2: Pointer): Integer;
  begin
    Result := Sign(PWall(w1)^.b - PWall(w2)^.b);
    if Result = 0 then
      Result := Sign(PWall(w1)^.a1 - PWall(w2)^.a1);
  end;
  
  function IsectWalls(const w: array of TWall; N: Integer): Integer;
  var
    wl: TList;
    w1, w2: PWall;
    i, j: Integer;
  begin
    Result := 0;
    wl := TList.Create;
    try
      for i := 1 to 2 * N do
        wl.Add(@w[i - 1]);
      wl.Sort(CompareWalls);
      i := 0;
      while i <= wl.Count - 2 do begin
        w1 := PWall(wl[i]);
        j := i + 1;
        while j <= wl.Count - 1 do begin
          w2 := PWall(wl[j]);
          if w2^.b > w1^.b then break;
          Inc(Result, IsectArea(w1^.a1, w1^.a2, w1^.h, w2^.a1, w2^.a2, w2^.h));
          if w2^.a2 > w1^.a2 then break;
          Inc(j);
        end;
        i := j;
      end;
    finally
      wl.Free;
    end;
  end;

var
  f: TextFile;
  i, N: Integer;
  s: Int64;
  a: array [1..100000] of THouse;
  w: array [1..200000] of TWall;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N);
  for i := 1 to N do
    with a[i] do
      Read(f, x1, y1, x2, y2, h);
  CloseFile(f);

  s := 0;
  for i := 1 to N do
    with a[i] do
      Inc(s, ((x2 - x1) + (y2 - y1)) * 2 * h + (x2 - x1) * (y2 - y1));

  for i := 1 to N do begin
    with w[2 * i - 1] do begin
      a1 := a[i].x1; a2 := a[i].x2; b := a[i].y1; h := a[i].h;
    end;
    w[2 * i] := w[2 * i - 1];
    w[2 * i].b := a[i].y2;
  end;
  Dec(s, IsectWalls(w, N));

  for i := 1 to N do begin
    with w[2 * i - 1] do begin
      a1 := a[i].y1; a2 := a[i].y2; b := a[i].x1; h := a[i].h;
    end;
    w[2 * i] := w[2 * i - 1];
    w[2 * i].b := a[i].x2;
  end;
  Dec(s, IsectWalls(w, N));

  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, s);
  CloseFile(f);
end.
